From 0b784f6f0d9e29b499b3f76a7c0fcc03e1a2af7b Mon Sep 17 00:00:00 2001
From: Sarper Akdemir <sarper.akdemir@collabora.com>
Date: Wed, 17 Aug 2022 16:23:29 +0300
Subject: [PATCH] tdf#144092 pptx import: correct table height during import

It appears PowerPoint can export rows of a table with row heights that
is less than the minimum height (for that row). And also export the
total table height wrong with it.

If PowerPoint imports such a table, those rows are individually
expanded to the minimum height. (Also increasing the table's total
height)

In Impress import we calculate table height by adding up individual
row heights. Table layouting code depends on the table height being
correct. This is why rows with less than minimum height lead to
layouting problems.

To compensate for this, while importing tables, layouting is skipped
until the table height is updated with the corrected height.

The correct height is calculated by layouting the table without
fitting to an area (i.e with bFit = false).

Change-Id: I79187882470a4e285b45bca1eabb469a084067f5
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/138652
Tested-by: Jenkins
Reviewed-by: Miklos Vajna <vmiklos@collabora.com>
(cherry picked from commit a5126a21351c87138ff86a6636326eb6cd6a0f8c)
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/139222
Tested-by: Jenkins CollaboraOffice <jenkinscollaboraoffice@gmail.com>
Reviewed-by: Sarper Akdemir <sarper.akdemir@collabora.com>
---
 include/svx/svdotable.hxx                     |   7 +++++
 oox/source/drawingml/shape.cxx                |  26 ++++++++++++++++++
 .../unit/data/pptx/tdf144092-tableHeight.pptx | Bin 0 -> 34887 bytes
 sd/qa/unit/export-tests-ooxml2.cxx            |   2 +-
 sd/qa/unit/import-tests2.cxx                  |  17 ++++++++++++
 svx/source/table/svdotable.cxx                |  12 ++++++++
 svx/source/table/tablelayouter.hxx            |   6 ++--
 7 files changed, 66 insertions(+), 4 deletions(-)
 create mode 100644 sd/qa/unit/data/pptx/tdf144092-tableHeight.pptx

diff --git a/include/svx/svdotable.hxx b/include/svx/svdotable.hxx
index e71c8517bb3f..71ec5b44bf57 100644
--- a/include/svx/svdotable.hxx
+++ b/include/svx/svdotable.hxx
@@ -258,6 +258,13 @@ public:
     /// Next time layouting would be done, skip it (to layout at the end of multiple actions).
     void SetSkipChangeLayout(bool bSkipChangeLayout);

+    /** Tries to get table height if rows with sizes less then the minimum size were expanded
+
+        (i.e. Table height layouted without fitting to an area)
+        Helper for OOXML import
+     */
+    sal_Int32 getHeightWithoutFitting();
+
     virtual void onEditOutlinerStatusEvent( EditStatus* pEditStatus ) override;

     virtual void dumpAsXml(xmlTextWriterPtr pWriter) const override;
diff --git a/oox/source/drawingml/shape.cxx b/oox/source/drawingml/shape.cxx
index 426f82381ba6..bbea8f21abab 100644
--- a/oox/source/drawingml/shape.cxx
+++ b/oox/source/drawingml/shape.cxx
@@ -89,6 +89,8 @@
 #include <com/sun/star/document/XActionLockable.hpp>
 #include <com/sun/star/chart2/data/XDataReceiver.hpp>
 #include <com/sun/star/text/GraphicCrop.hpp>
+#include <svx/svdobj.hxx>
+#include <svx/svdotable.hxx>
 #include <svx/svdtrans.hxx>
 #include <tools/stream.hxx>
 #include <unotools/streamwrap.hxx>
@@ -716,6 +718,8 @@ Reference< XShape > const & Shape::createAndInsert(
         maSize.Height = 0;
         for (auto const& elem : mpTablePropertiesPtr->getTableRows())
         {
+            // WARN: When less then minimum sized rows exist, calculated height here
+            // is corrected before layouting takes place
             maSize.Height = o3tl::saturating_add(maSize.Height, elem.getHeight());
         }
     }
@@ -1141,7 +1145,14 @@ Reference< XShape > const & Shape::createAndInsert(
             mpGraphicPropertiesPtr->pushToPropMap( aShapeProps, rGraphicHelper, mbFlipH, mbFlipV );
         }
         if ( mpTablePropertiesPtr && aServiceName == "com.sun.star.drawing.TableShape" )
+        {
             mpTablePropertiesPtr->pushToPropSet( rFilterBase, xSet, mpMasterTextListStyle );
+            if ( auto* pTableShape = dynamic_cast<sdr::table::SdrTableObj*>(SdrObject::getSdrObjectFromXShape(mxShape)) )
+            {
+                // Disable layouting until an attempt at correcting faulty table height is made
+                pTableShape->SetSkipChangeLayout(true);
+            }
+        }

         FillProperties aFillProperties = getActualFillProperties(pTheme, &rShapeOrParentShapeFillProps);
         if (getFillProperties().moFillType.has() && getFillProperties().moFillType.get() == XML_grpFill)
@@ -1372,6 +1383,21 @@ Reference< XShape > const & Shape::createAndInsert(
             }

             PropertySet( xSet ).setProperties( aShapeProps );
+
+            if (mpTablePropertiesPtr && aServiceName == "com.sun.star.drawing.TableShape")
+            {
+                // Powerpoint sometimes export row heights less than the minimum size,
+                // which during import expanded to the minimum
+                if (auto* pTableShape = dynamic_cast<sdr::table::SdrTableObj*>(SdrObject::getSdrObjectFromXShape(mxShape)))
+                {
+                    sal_Int32 nCorrectedHeight = pTableShape->getHeightWithoutFitting();
+                    const auto& aShapeSize = mxShape->getSize();
+                    if( nCorrectedHeight > aShapeSize.Height )
+                        mxShape->setSize( {aShapeSize.Width, nCorrectedHeight} );
+                    pTableShape->SetSkipChangeLayout(false);
+                }
+            }
+
             if (mbLockedCanvas)
             {
                 putPropertyToGrabBag( "LockedCanvas", Any( true ) );
diff --git a/svx/source/table/svdotable.cxx b/svx/source/table/svdotable.cxx
index 4ed1eaec2f60..a4da6f1cf68b 100644
--- a/svx/source/table/svdotable.cxx
+++ b/svx/source/table/svdotable.cxx
@@ -2407,6 +2407,18 @@ void SdrTableObj::CropTableModelToSelection(const CellPos& rStart, const CellPos
     mpImpl->CropTableModelToSelection(rStart, rEnd);
 }

+sal_Int32 SdrTableObj::getHeightWithoutFitting()
+{
+    tools::Rectangle aRect{};
+    if( mpImpl.is() && mpImpl->mpLayouter)
+    {
+        mpImpl->mpLayouter->LayoutTableHeight(aRect, /*bFit=*/false);
+        return aRect.GetHeight();
+    }
+    else
+        return 0;
+}
+
 void SdrTableObj::DistributeColumns( sal_Int32 nFirstColumn, sal_Int32 nLastColumn, const bool bOptimize, const bool bMinimize )
 {
     if( mpImpl.is() && mpImpl->mpLayouter )
